% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.1 Common ideal filters%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a

Hd=zeros(1,512)';
w=linspace(0,0.5,512)*2*pi;
for i=1:512
    if w(i)<=0.5*pi
        Hd(i)=1;
    end
end
Hd_lp=Hd;
figure,plot(w,abs(Hd_lp),'k','LineWidth',3)
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\itH_d}({\it\omega})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.05])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b

Hd_hp=1-Hd;
figure
plot(w,abs(Hd_hp),'k','LineWidth',3)
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\itH_d}({\it\omega})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.05])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%c

Hd_bp=zeros(1,512)';
w=linspace(0,0.5,512)*2*pi;
for i=1:512
    if w(i)<=0.75*pi &&  w(i)>=0.25*pi
        Hd_bp(i)=1;
    end
end
Hd_bs=1-Hd_bp;
figure
plot(w,abs(Hd_bp),'k','LineWidth',3)
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\itH_d}({\it\omega})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.05])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%d

Hd_n=zeros(1,512)';
w=linspace(0,0.5,512)*2*pi;
for i=1:512
    if w(i)<=0.53*pi &&  w(i)>=0.5*pi
        Hd_n(i)=1;
    end
end
figure
plot(w,1-abs(Hd_n),'k','LineWidth',3)
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\itH_d}({\it\omega})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.05])
set(gcf,'PaperPositionMode','auto')

