% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.12 Linear-phase FIR filters designed via the frequency-sampling method%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

f = [0 0.5 0.5 1]; m = [1 1 0 0];

b1 = fir2(10,f,m);
[h1,w] = freqz(b1,1,128);

b2 = fir2(30,f,m);
[h2,w] = freqz(b2,1,128);

b3 = fir2(50,f,m);
[h3,w] = freqz(b3,1,128);

plot(w,abs(h1),'k',w,abs(h2),'k--',w,abs(h3),'k-.','LineWidth',2)
hhh=legend('{\itM}=11','{\itM}=31','{\itM}=51');
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\it H}({\it e^{\it j\omega}})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.1])
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')

figure
plot(w,unwrap(angle(h1)),'k',w,unwrap(angle(h2)),'k--',w,unwrap(angle(h3)),'k-.','LineWidth',2)
hhh=legend('{\itM}=11','{\itM}=31','{\itM}=51');
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('{\it \angle{H}}({\it e^{\it j\omega}})','FontName','Times','FontSize',14)
axis([0,pi,-60,5])
hold off
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')


