% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.15 Linear-phase FIR filters designed via the POCS method%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

N=11;
delta_p=1E-3;
delta_s=1E-3;
num_pts=512;
wc_p=0.25;
wc_s=0.3;
threshold=1E-15;
P='Z';

[b1,H,Mz,magH,angH,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec1]=pocs_1Dtest_matlab(wc_p,wc_s,delta_p,delta_s,N,num_pts,threshold,P);
[h1,w] = freqz(b1,1,num_pts,'whole');
N=31;
delta_p=1E-3;
delta_s=1E-3;
wc_p=0.25;
wc_s=0.3;
threshold=1E-15;
P='Z';

[b2,H,Mz,magH,angH,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec2]=pocs_1Dtest_matlab(wc_p,wc_s,delta_p,delta_s,N,num_pts,threshold,P);
[h2,w] = freqz(b2,1,num_pts,'whole');
N=51;
delta_p=1E-3;
delta_s=1E-3;
wc_p=0.25;
wc_s=0.3;
threshold=1E-15;
P='Z';

[b3,H,Mz,magH,angH,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec3]=pocs_1Dtest_matlab(wc_p,wc_s,delta_p,delta_s,N,num_pts,threshold,P);
[h3,w] = freqz(b3,1,num_pts,'whole');
h1=fftshift(h1);
h2=fftshift(h2);
h3=fftshift(h3);

%%a
plot(w,abs(h1),'k',w,abs(h2),'k--',w,abs(h3),'k-.','LineWidth',2)
hhh=legend('{\itM}=11','{\itM}=31','{\itM}=51');
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\it H}({\it e^{\it j\omega}})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.1])
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')

%%b
h1=fftshift(h1);
h2=fftshift(h2);
h3=fftshift(h3);
figure
plot(w,unwrap(angle(fftshift(h1))),'k',w,unwrap(angle(fftshift(h2))),'k--',w,unwrap(angle(fftshift(h3))),'k-.','LineWidth',2)
hhh=legend('{\itM}=11','{\itM}=31','{\itM}=51');
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('{\it \angle{H}}({\it e^{\it j\omega}})','FontName','Times','FontSize',14)
axis([0,pi,-60,5])
hold off
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')
%% c: Ploting the error vs the number of iterations

figure,semilogy([1:length(D_error_vec1)],D_error_vec1,'k',[1:length(D_error_vec2)],D_error_vec2,'k--',[1:length(D_error_vec3)],D_error_vec3,'k-.','LineWidth',2)
hhh=legend('{\itM}=11','{\itM}=31','{\itM}=51');
xlabel('Iterations','FontName','Times','FontSize',14)
ylabel('Error','FontName','Times','FontSize',14)
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')


