% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.17 Example 5.1%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Transfer function numerator coefficients 
num=[1,0.1]
%Transfer function denominator coefficients 
den=[1,0.2,9.01]
%Analog filter frequency response
[Ha,Omega]=freqs(num,den);
%Sampling time and frequency
T=0.1;
fs=1/T;
%Digitla trasfer function coefficients using the bilinear transformation
%technique
[bz,az]=bilinear(num,den,fs)
%Its frequency response
[H,w]=freqz(bz,az,128);

figure
plot(Omega,(abs(Ha)),'k-.',w*fs,(abs(H)),'k','LineWidth',2)
xlabel('Frequency (Hz)','FontName','Times','FontSize',14)
hhh=legend('|{\it H_a}({\it F})|','|{\it H}({\it e^{\it jf}})|');
axis([0,15,0,5])
set(hhh,'FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')


