% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.18 Example 5.2%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dt=0.004;
fs=1/dt;
num=[1,2,1];
den=[3.64,-0.268,0.628];
[H,w]=freqz(num,den,128);
w=fs*w/(2*pi);
figure,plot(w,abs(H),'k','LineWidth',3)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('|{\it H}({\it e^{\it jf}})|','FontName','Times','FontSize',14)
axis tight
grid
set(gcf,'PaperPositionMode','auto')

figure,plot(w,unwrap(angle(H)),'k','LineWidth',3)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('{\it \angle{H}}({\it e^{\it jf}})','FontName','Times','FontSize',14)
axis tight
grid
set(gcf,'PaperPositionMode','auto')

