% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.19 Example 5.3%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dt=0.004;
fs=1/dt;
Fu=60;
Fl=10;
omega_c=[pi*(Fu+Fl)/fs]
Fu=Fu/fs;
Fl=Fl/fs;
A=cot(pi*(Fu-Fl));
B=2*cos(pi*(Fu+Fl))/cos(pi*(Fu-Fl));
m=A/omega_c;

num=[1,0,-2,0,1]

den=[(m^2+sqrt(2)*m+1),-B*(2*m^2+sqrt(2)*m),((2+B^2)*m^2-2),...
    -B*(2*m^2-sqrt(2)*m),(m^2-sqrt(2)*m+1)]

[H,w]=freqz(num,den,256);
w=fs*w/(2*pi);
figure,plot(w,abs(H),'k','LineWidth',3)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('|{\it H}({\it e^{\it jf}})|','FontName','Times','FontSize',14)
axis tight
grid
set(gcf,'PaperPositionMode','auto')


figure,plot(w,unwrap(angle(H)),'k','LineWidth',3)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('{\it \angle{H}}({\it e^{\it jf}})','FontName','Times','FontSize',14)
axis tight
grid
set(gcf,'PaperPositionMode','auto')

