% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.22 Seismic wavefield extrapolation FIR filters designed via the POCS method%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delta_p=1E-3;
delta_s=1E-3;
num_pts=512;
wc_p=0.25;
wc_s=0.28;
threshold=1E-15;
dz=5;
dx=20;
b=dz/dx;
P='S';

%%
N=25;
[b1,H,Mz,magH1,angH1,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec1]=pocs_1Dtest_matlab(wc_p,wc_s,delta_p,delta_s,N,num_pts,threshold,P,b);
%%
N=35;
[b2,H,Mz,magH2,angH2,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec2]=pocs_1Dtest_matlab(wc_p,wc_s,delta_p,delta_s,N,num_pts,threshold,P,b);
%%
N=55;
[b3,H,Mz,magH3,angH3,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec3]=pocs_1Dtest_matlab(wc_p,wc_s,delta_p,delta_s,N,num_pts,threshold,P,b);


w=kx*2*pi;
plot(w,magH1,'k',w,magH2,'k--',w,magH3,'k-.','LineWidth',2)
hhh=legend('{\itM}=25','{\itM}=35','{\itM}=55');
xlabel('{\it k_x} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\it H}({\it e^{\it jk_x}})|','FontName','Times','FontSize',14)
axis([0,pi,0,1.1])
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')


figure
plot(w,angH1,'k',w,angH2,'k--',w,angH3,'k-.','LineWidth',2)
hhh=legend('{\itM}=25','{\itM}=35','{\itM}=55');
xlabel('{\it k_x} (rad/s)','FontName','Times','FontSize',14)
ylabel('{\it \angle{H}}({\it e^{\it jk_x}})','FontName','Times','FontSize',14)
axis([0,pi,0,0.065])
hold off
grid on
set(hhh,'FontName','Times')
set(gcf,'PaperPositionMode','auto')
