% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.27 Design of 2D Fan filters using the windowing method%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%-------------------------------------------
%Filter parameters
delta_p=1E-3;%eps;
delta_s=1E-5;
N=45;
%No. of points
nf=128;
nk=128;
%Angle(if theta==90degrees, we simply have an all pass filter)
theta=35;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a
[h,kx,f]=fan_filter(theta,delta_s,N,nf,nk,'P','R');
D1=fft2(h,nf,nk);
figure,
mesh(kx*2*pi,f*2*pi,abs(D1))
axis tight
view(3)
colormap(sgray)
zlabel('|{\it H}({\it e^{j\omega},e^{\it jk}})|','FontName','Times','FontSize',14)
xlabel('{\it k} (rad/m)','FontName','Times','FontSize',14)
ylabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
shading interp
camlight; 
lighting phong
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b
[h,kx,f]=fan_filter(theta,delta_s,N,nf,nk,'P','K');
D1=fft2(h,nf,nk);
figure,
mesh(kx*2*pi,f*2*pi,abs(D1))
axis tight
view(3)
colormap(sgray)
zlabel('|{\it H}({\it e^{j\omega},e^{\it jk}})|','FontName','Times','FontSize',14)
xlabel('{\it k} (rad/m)','FontName','Times','FontSize',14)
ylabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
shading interp
camlight; 
lighting phong
set(gcf,'PaperPositionMode','auto')


