% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.4 Frequency-response of various rectangular windows%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


M=11;
n=0:M-1;
w=ones(1,M);
[W1]=freqz(w,128);

M=31;
n=0:M-1;
w=ones(1,M);
[W2]=freqz(w,128);


M=51;
n=0:M-1;
w=ones(1,M);
[W3,omg]=freqz(w,128);

plot(omg,abs(W1)/max(abs(W1)),'b','LineWidth',2)
hold on,
plot(omg,abs(W2)/max(abs(W2)),'r-.','LineWidth',2)
plot(omg,abs(W3)/max(abs(W3)),'k--','LineWidth',2)
xlabel('\omega(rad/s)','FontName','Times','FontSize',14)
ylabel('|W(\omega)|','FontName','Times','FontSize',14)
axis tight
hold off
legend('{\itM}=11','{\itM}=31','{\itM}=51','FontName','Times')





