% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 5 MATLAB codes %%%
%%% Figure 5.5 Linear-phase FIR LPF designed with various rectrangular windows%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

M=10;
n=0:M;
h1=fir1(M,0.5,rectwin(M+1));
[W1]=freqz(h1,128);
figure
stem(n,h1,'k','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14);
ylabel('{\ith}[{\itn}]','FontName','Times','FontSize',14);
axis tight
legend('{\itM}=11','FontName','Times')


M=30;
n=0:M;
h2=fir1(M,0.5,rectwin(M+1));
[W2]=freqz(h2,128);
figure
stem(n,h2,'k','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14);
ylabel('{\ith}[{\itn}]','FontName','Times','FontSize',14);
axis tight
legend('{\itM}=31','FontName','Times')


M=50;
n=0:M;
h3=fir1(M,0.5,rectwin(M+1));
[W3,omg]=freqz(h3,128);

figure
stem(n,h3,'k','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14);
ylabel('{\ith}[{\itn}]','FontName','Times','FontSize',14);
axis tight
legend('{\itM}=51','FontName','Times')


Hd=zeros(1,512)';
w=linspace(0,0.5,512)*2*pi;
for i=1:512
    if w(i)<=0.5*pi
        Hd(i)=1;
    end
end

figure
plot(w,abs(Hd)/max(abs(Hd)),'b','LineWidth',2)
hold on,
plot(omg,abs(W1)/max(abs(W1)),'m','LineWidth',2)
plot(omg,abs(W2)/max(abs(W2)),'r-.','LineWidth',2)
plot(omg,abs(W3)/max(abs(W3)),'k--','LineWidth',2)
xlabel('\omega(rad/s)','FontName','Times','FontSize',14)
ylabel('|{\itH}(\omega)|','FontName','Times','FontSize',14)
axis([0,pi,0,1.05])
hold off
grid on
legend('Ideal','{\itM}=11','{\itM}=31','{\itM}=51','FontName','Times')

figure
hold on,
plot(omg,unwrap(angle(W1)),'m','LineWidth',2)
plot(omg,unwrap(angle(W2)),'r-.','LineWidth',2)
plot(omg,unwrap(angle(W3)),'k--','LineWidth',2)
xlabel('\omega(rad/s)','FontName','Times','FontSize',14)
ylabel('\angle{{\itH}(\omega)}','FontName','Times','FontSize',14)
hold off
grid on
legend('{\itM}=11','{\itM}=31','{\itM}=51','FontName','Times')





