function [h,kx,w]=fan_filter(theta,delta_s,N,nf,nk,ZZ,P);

%Angle(if theta==90degrees, we simply have an all pass migration filter)
theta=theta*pi/180;
%-------------------------------------------
%Ideal filter
kx=linspace(-0.5,0.5,nk);
%Frequency in radian
w=linspace(-0.5,0.5,nf);
%The ideal filter
if ZZ=='P' %% a pass fan filter
D=zeros(nf,nk);
for m=1:nf
    for n=1:nk
            if (abs(atan(kx(n)/(w(m)+eps)))<=theta)
                 D(m,n)=1;
            end
    end
end
elseif ZZ=='R' %% a reject fan filter
    D=ones(nf,nk);
for m=1:nf
    for n=1:nk
            if (abs(atan(kx(n)/(w(m)+eps)))<=theta)
                 D(m,n)=0;
            end
    end
end
end
%-------------------------------------------
h=fftshift(ifft2(D,nf,nk));
[mmm,nnn]=size(h);
if P=='H'    
    nnnn=[-(N+1)/2+1:(N+1)/2-1];
    alpha=0.50;
    Hamming_t=(alpha+(1-alpha)*cos(2*pi*nnnn/N));
    Hamming_fn=zeros(mmm,nnn);
    Hamming_fn((mmm/2-((N-1)/2)+1):(mmm/2+((N-1)/2)+1),(nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1))=Hamming_t'*Hamming_t;
    h=h.*Hamming_fn;
elseif P=='K'
    [Ka_t,delta_k]=Kaiser_win(N,delta_s);
    Ka_fn=zeros(mmm,nnn);
    Ka_fn((mmm/2-((N-1)/2)+1):(mmm/2+((N-1)/2)+1),(nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1))=Ka_t'*Ka_t;
    h=h.*Ka_fn;
elseif P=='R'
    Rect_fn=zeros(mmm,nnn);
    Rect_fn((mmm/2-((N-1)/2)+1):(mmm/2+((N-1)/2)+1),(nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1))=1;
    h=h.*Rect_fn;
end   

h=h((mmm/2-((N-1)/2)+1):(mmm/2+((N-1)/2)+1),(nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1));
h=real(h);
