function [h,H,Mz,magH,angH,Hid,kx,kc_p,kc_s,bb_vec,D_error_vec]=pocs_1Dtest_matlab(kc_p,kc_s,delta_p,delta_s,N,num_pts,threshold,P,b)

%Modified POCS
%-------------------------------------------
%Ideal filter
kx=linspace(-0.5,0.5,num_pts);

if P=='Z'
%The ideal filter
Hid=zeros(1,num_pts);
for m=1:num_pts
    if  (abs(kx(m))<=abs(kc_p))
        Hid(m)=1;
    end
end
elseif P=='L'
%The ideal filter
Hid=zeros(1,num_pts);
for m=1:num_pts
        Hid(m)=1*exp(-j*kx(m)*(N-1)/2);
end
elseif P=='G'
%The ideal filter
d=0.5;
Hid=zeros(1,num_pts);
for m=1:num_pts
    if  (abs(kx(m))<=abs(kc_p))
        Hid(m)=exp(-j*kx(m)*(d+(N-1)/2));
    end
end
elseif P=='S'
%The ideal filter
Hid=zeros(1,num_pts);
% kx=2*pi*kx;
% kc_p=kc_p*2*pi;
for m=1:num_pts
    if  (abs(kx(m))<=abs(kc_p))
        Hid(m)=exp(j*b*sqrt(kc_p^2-(kx(m))^2));
    end
end
end

%-------------------------------------------
%The POCS algorithm parameters
%-------------------------------------------
%No of FFT points
num_pts=length(Hid);
%Initial vector (ideal filter)
h=ifft(Hid,num_pts);
%Just to strat the code
D_error=1;
%Initilizing the counter
bb=0;
[mmm,nnn]=size(h);
Rect_fn=zeros(mmm,nnn);
Rect_fn((nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1))=1;

[Ka_t]=Kaiser_win(N,delta_s);
Ka_fn=zeros(mmm,nnn);
Ka_fn((nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1))=Ka_t;

Nn=floor(1/(kc_p+kc_p))+2;
sparse_rect_fn=ones(1,N);
sparse_rect_fn((N+1)/2+Nn:Nn:N)=0;
sparse_rect_fn((N+1)/2)=1;
sparse_rect_fn(1:(N+1)/2-1)=sparse_rect_fn(N:-1:(N+1)/2+1);
sRect_fn=zeros(mmm,nnn);
sRect_fn((nnn/2-((N-1)/2)+1):(nnn/2+((N-1)/2)+1))=sparse_rect_fn;


%--------------------------------------------------------------------------
%POCS algorithm
%--------------------------------------------------------------------------
while (D_error>threshold)
bb=bb+1;
disp(['I am iteration number ',num2str(bb),' '])
%h is of length odd N
h_old=h;
H=fft(h,num_pts);
G=zeros(1,num_pts);
G1=zeros(1,num_pts);
G2=zeros(1,num_pts);
G3=zeros(1,num_pts);
%--------------------------------------------------------------------------
G=H.*(abs(H) <= delta_s & abs(kx) >= kc_s)...
    -delta_s*exp(j*angle(H)).*(abs(H) > delta_s & abs(kx) >= kc_s)...
    +H.*(abs(kx) < kc_s);
%--------------------------------------------------------------------------
%Projection onto C4
G1=G.*(abs(G) <= (1+delta_p) & abs(kx) <= kc_p)...
    -(1+delta_p)*exp(j*angle(G)).*(abs(G) > (1+delta_p) & abs(kx) <= kc_p)...
    +G.*(abs(kx) > kc_p);
%--------------------------------------------------------------------------
%Projection onto C3
G2=G1.*(abs(G1) >= (1-delta_p) & abs(kx) <= kc_p)...
    +(1-delta_p)*exp(j*angle(G1)).*(abs(G1) < (1-delta_p) & abs(kx) <= kc_p)...
    +G1.*(abs(kx) > kc_p);
%--------------------------------------------------------------------------
%Projection onto C2 (Derive me first)
G3=(abs(G2).*cos(angle(G2)-angle(Hid)).*exp(j*angle(Hid))).*(cos(angle(G2)-angle(Hid)) >= 0)...
    -(abs(G2).*cos(angle(G2)-angle(Hid)).*exp(j*angle(Hid))).*(cos(angle(G2)-angle(Hid)) < 0);
%--------------------------------------------------------------------------



%this is Pc1 as g mulitplied by a window of ones in -(N-1)/2 <= n <= (N-1)/2
if P=='Z'
%Projection onto C1
g=real(fftshift(ifft(G3)));
h=g.*Rect_fn;
elseif P=='L'
%Projection onto C1
g=fftshift(ifft(G3));
gr=real(g);
h=gr.*Rect_fn;
elseif P=='G'
%Projection onto C1
g=fftshift(ifft(G3));
h=g.*Rect_fn;
else
%Projection onto C1
g=fftshift(ifft(G3));
gr=real(g);
gi=imag(g);
g(num_pts:-1:num_pts/2+2)=g(2:num_pts/2);


h=(gr+j*gi).*Ka_fn;
%h=(gr+j*gi).*Rect_fn;
%h=(gr+j*gi).*sRect_fn;

 
end   
%--------------------------------------------------------------------------
clear G G1 G2 G3 
%--------------------------------------------------------------------------


    

%Stopping criterion
if (bb>1)
    %D_error=norm(h-h_old);
    D_error=mean(abs(h-h_old).^2);
    disp(['The Distance Error is: ',num2str(D_error),'']);
    D_error_vec(bb)=D_error;
end

end%while
%--------------------------------------------------------------------------
%End of the POCS algorithm
%--------------------------------------------------------------------------
%Distance Error
bb_vec=1:bb;
H=fft(h,num_pts);
magH=(abs(H));
angH=atan(imag(H)./real(H));
[mmm,nnn]=size(h);
h=h((nnn/2+1):(nnn/2+((N-1)/2)+1));
htmp=zeros(1,N);
htmp((N+1)/2:N)=h;
htmp(1:(N+1)/2-1)=h((N+1)/2:-1:2);
h=htmp;
Mz=length(find(h==0));
100*(Mz/N);
